<template>
    <div class="">
            <b-modal @hidden="reset"  size="lg" ref="optionsModal" id="my-modal-assurance" :title="ModalTitle"  :hide-footer="true">
                <form class="" method="POST"  @submit.prevent="update()"
                      @reset.prevent="reset()"
                      @keydown="form.errors.clear($event.target.name)"
                      @change="form.errors.clear($event.target.name)">
                    <div class="row">
                        <div class="form-group col-md-12">
                            <label class="">Options de sécurité</label>
                                <multi-select
                                    no-ptions="Aucun revendeur disponible" open-direction="bottom"
                                    v-model="securites"  :options="opt.optSecurite" :multiple="true" :taggable="true" @tag="addSecuriteOpt"
                                    :show-labels="false" :searchable="true" :clear-on-select="false"
                                    :close-on-select="true"  placeholder="Choisissez les options de sécurité" label="libelle" track-by="id">
                                </multi-select>
                            <span class="m-form__help m--font-danger" ></span>
                        </div>
                        <div class="form-group col-md-12">
                            <label class="">Options de confort</label>
                                <multi-select
                                    no-ptions="Aucun revendeur disponible" open-direction="bottom" name="options.*.id "
                                    v-model="conforts"  :options="opt.optConfort" :multiple="true" :taggable="true"
                                    :show-labels="false" :searchable="true" :clear-on-select="false"
                                    :close-on-select="true"  placeholder="Choisissez les options de confort" label="libelle" track-by="id">
                                </multi-select>
                            <span class="m-form__help m--font-danger"  v-if="form.errors.has('options.*.id')" v-text="form.errors.get('options.*.id')"></span>
                        </div>
                        <div class="form-group col-md-12">
                            <label class="">Options de plaisir</label>
                                <multi-select
                                    no-ptions="Aucun revendeur disponible" open-direction="bottom"
                                    v-model="plaisirs"  :options="opt.optPlaisir" :multiple="true" :taggable="true"
                                    :show-labels="false" :searchable="true" :clear-on-select="false"
                                    :close-on-select="true"  placeholder="Choisissez les options de plaisir" label="libelle" track-by="id">
                                </multi-select>
                            <span class="m-form__help m--font-danger"  ></span>
                        </div>
                    </div>
                    <div class="m-form__actions m-form__actions--solid mt-3" style="    display: flex;align-items: center;justify-content: flex-end;">
                        <button type="submit" :class="['btn btn-success btn-small ',isLoading ? 'm-loader m-loader--sm m-loader--light m-loader--right' :'']" :disabled="form.errors.any() || isLoading">{{ isLoading ? "Processus en cours..." : ModalAction }}</button>
                    </div>
                </form>
            </b-modal>
            <!-- Modal fin -->
        </div>
</template>

<script>

    import Form from "./../../classes/Form"


    export default {
        props:[],
        data(){
            return{
 
                isLoading:false,
                //multi-select
                marque:"",
                modele:"",
                motorisation:"",
                permis:"",
                tvehicule:"",

                //Options selectionnées
                plaisirs : [],
                conforts : [],
                securites : [],

                opt:{
                    marques:[],
                    motorisations:[],
                    tvehicules:[],
                    optConfort:[],
                    optPlaisir:[],
                    optSecurite:[],
                    tpermis:[],
                },
                form : new Form(
                    {
                        image_mise_en_avant:"",
                        images:[],
                        marque_id:"",
                        modele_id:"",
                        libelle:"",
                        type_vehicule_id: "",
                        type_permis_id: "",
                        step:0,

                        options:[],

                        nbr_place: "",
                        nbr_porte: "",
                        couleur: "",

                        //tarifs
                        tarif: "",
                        kilometrage: "",

                        //unicités
                        plaque_immatriculation: "",
                        nr_chassis: "",

                        date_mise_en_circulation: "",
                        annee_mise_en_circulation: "",
                        consommation_au_100_km: "",

                        //moteurs
                        type_motorisation_id: "",
                        boite_vitesse: "",

                        //mesures physiques
                        volume_coffre: "",
                        volume_reservoir: "",
                        largeur: "",
                        longueur: "",
                        poids: "",
                        hauteur: ""
                  }),
            }
        },
        created()
        {
               this.modeEdit = false
               axios.get("/api/dispatcher/options/vehicules").then((response) =>
                {
                      response.data.voptions.forEach( e =>
                      {

                        if(e.code == "SEC")
                          this.opt.optSecurite = e.options
                        if(e.code == "CNF")
                         this.opt.optConfort = e.options
                        if(e.code == "PLS")
                         this.opt.optPlaisir = e.options
                      }  )


                      //envoie un event pour signifier le chargement des options
                },
                (error) =>
                {
                  this.isLoading = false
                });
             
          
        },
        mounted() {

              window.event.$on('change-options-event',(vehicule) =>
             {
                 this.entity = vehicule
                 this.showModal()
             })
        },
        computed:
            {
                ModalTitle ()
                {
                    return "Modification : Options"
                },
                ModalAction ()
                {
                    return  " Valider"
                },
                 //Fusions les tableaux d'options
                OptionsPack ()
                {

                var arr = []
                _.merge(arr,[this.securites,this.plaisirs,this.conforts])
                return _.uniq(_.flatten(arr))

                },
                 //Recupere les ids des tableaux d'options
                OptionsIds()
                {

                if(this.OptionsPack.length!=0)
                {
                    var arr = this.OptionsPack.map( e => {return e.id});
                    return arr
                }
                else
                return []


                },
            },
        methods:
            {
            addSecuriteOpt(option)
            {
              console.log(option)
            },
                //Event sur le date picker
                datepickerEvent(event,name)
                {
                    if(name=="date_dbt")
                    {
                        this.form.date_dbt = moment(event).format('YYYY-MM-DD')
                        this.form.checkError

                    }
                    if(name=="date_fin_prev")
                    {
                    this.form.date_fin_prev = moment(event).format('YYYY-MM-DD')
                    this.form.checkError
                    }
                },
                //Actualise les données générales
                update()
                {
                    this.isLoading = true ;
                    //Requête ajax
                    this.form.patch("/api/vehicules/"+this.entity.id+"/updateOptions").then((response) =>
                        {
                            if(response.success)
                            {
                             flash("<span>Enregistré <strong>avec succès</strong></span>")
                             window.event.$emit('updated-options-event',response.entity)
                            }
                            else
                            {
                             flash("<span>Ajout<strong> impossible</strong></span>","error")
                            }

                            this.isLoading = false ;
                            this.reset()

                        },
                        (error) =>
                        {
                            this.isLoading = false
                        });
                },
                //On affiche le modal 
                showModal()
                {

                    this.modeEdit = false
                    this.init()
                    this.$refs['optionsModal'].show()

                },

                //Initialisation du formulaire
                reset()
                {

                    this.$refs['optionsModal'].hide()
                    this.plaisirs = [],
                    this.conforts = [],
                    this.securites = [],
                    this.modeEdit = false
                    this.isLoading = false
                },
                init()
                {
                    this.form.marque_id=this.entity.marque_id,
                    this.form.modele_id=this.entity.modele_id,
                    this.form.libelle=this.entity.libelle,
                    this.form.type_vehicule_id= this.entity.type_vehicule_id,
                    this.form.type_permis_id= this.entity.type_permis_id,
                    this.form.type_motorisation_id= this.entity.type_motorisation_id,

                    this.form.nbr_place= this.entity.nbr_place,
                    this.form. nbr_porte= this.entity.nbr_porte,
                    this.form.couleur= this.entity.couleur,

                    //tarifs
                    this.form.tarif= this.entity.tarif,
                    this.form.kilometrage= this.entity.kilometrage,

                    //unicités
                    this.form.plaque_immatriculation= this.entity.plaque_immatriculation,
                    this.form.nr_chassis= this.entity.nr_chassis,

                    this.form.date_mise_en_circulation= this.entity.date_mise_en_circulation,
                    this.date_pmc = moment(this.form.date_mise_en_circulation).toDate()

                    this.form.annee_mise_en_circulation= moment(this.form.date_mise_en_circulation).year(),
                    this.form.consommation_au_100_km= this.entity.consommation_au_100_km,

                    //moteurs

                    this.form.boite_vitesse= this.entity.boite_vitesse,

                    //mesures physiques
                    this.form.volume_coffre= this.entity.volume_coffre,
                    this.form.volume_reservoir= this.entity.volume_reservoir,
                    this.form.largeur= this.entity.largeur,
                    this.form.longueur= this.entity.longueur,
                    this.form.poids= this.entity.poids,
                    this.form.hauteur= this.entity.hauteur

                    //
                    this.securites = this.entity.options.filter(e =>  e.type_option_id == 1)
                    this.conforts = this.entity.options.filter(e =>  e.type_option_id == 2)
                    this.plaisirs = this.entity.options.filter(e =>  e.type_option_id == 3)


            }
            },
        components:
            {

            },
        watch:
         {
            "OptionsIds":function(val)
             {
                 this.form.options = val
             }
         }
    }
</script>
